## cataclysm-dda 0.D

=== Makefile ===
# vim: set expandtab tabstop=4 softtabstop=2 shiftwidth=2:
# Platforms:
# Linux/Cygwin native
#   (don't need to do anything)
# Linux 64-bit
#   make NATIVE=linux64
# Linux 32-bit
#   make NATIVE=linux32
# Linux cross-compile to Win32
#   make CROSS=i686-pc-mingw32-
#   or make CROSS=i586-mingw32msvc-
#   or whichever prefix your crosscompiler uses
#      as long as its name contains mingw32
# Linux cross-compile to OSX with osxcross
#   make CROSS=x86_64-apple-darwin15-
#        NATIVE=osx
#        CLANG=1
#        OSXCROSS=1
#        LIBSDIR=../libs
#        FRAMEWORKSDIR=../Frameworks
# Win32 (non-Cygwin)
#   Run: make NATIVE=win32
# OS X
#   Run: make NATIVE=osx

# Build types:
# Debug (no optimizations)
#  Default
# ccache (use compilation caches)
#  make CCACHE=1
# Release (turn on optimizations)
#  make RELEASE=1
# Tiles (uses SDL rather than ncurses)
#  make TILES=1
# Sound (requires SDL, so TILES must be enabled)
#  make TILES=1 SOUND=1
# Disable gettext, on some platforms the dependencies are hard to wrangle.
#  make LOCALIZE=0
# Disable backtrace support, not available on all platforms
#  make BACKTRACE=0
# Compile localization files for specified languages
#  make localization LANGUAGES="<lang_id_1>[ lang_id_2][ ...]"
#  (for example: make LANGUAGES="zh_CN zh_TW" for Chinese)
#  make localization LANGUAGES=all
#  (for every .po file in lang/po)
# Enable sanitizer (address, undefined, etc.)
#  make SANITIZE=address
# Change mapsize (reality bubble size)
#  make MAPSIZE=<size>
# Adjust names of build artifacts (for example to allow easily toggling between build types).
#  make BUILD_PREFIX="release-"
# Generate a build artifact prefix from the other build flags.
#  make AUTO_BUILD_PREFIX=1
# Install to system directories.
#  make install
# Enable lua support. Required only for full-fledged mods.
#  make LUA=1
# Use user's XDG base directories for save files and configs.
#  make USE_XDG_DIR=1
# Use user's home directory for save files.
#  make USE_HOME_DIR=1
# Use dynamic linking (requires system libraries).
#  make DYNAMIC_LINKING=1
# Use MSYS2 as the build environment on Windows
#  make MSYS2=1
# Astyle the source files that aren't blacklisted. (maintain current level of styling)
#  make astyle
# Check if source files are styled properly (regression test, astyle_blacklist tracks un-styled files)
#  make astyle-check
# Astyle all source files using the current rules (don't PR this, it's too many changes at once).
#  make astyle-all
# Style the whitelisted json files (maintain the current level of styling).
#  make style-json
# Style all json files using the current rules (don't PR this, it's too many changes at once).
#  make style-all-json
# Disable astyle of source files.
# make ASTYLE=0
# Disable format check of whitelisted json files.
# make LINTJSON=0
# Disable building and running tests.
# make RUNTESTS=0

# comment these to toggle them as one sees fit.
# DEBUG is best turned on if you plan to debug in gdb -- please do!
# PROFILE is for use with gprof or a similar program -- don't bother generally
# RELEASE is flags for release builds, this disables some debugging flags and
# enforces build failure when warnings are encountered.
# We want to error on everything to make sure we don't check in code with new warnings.
RELEASE_FLAGS = -Werror
WARNINGS = -Wall -Wextra
# Uncomment below to disable warnings
#WARNINGS = -w
DEBUGSYMS = -g
ifeq ($(shell sh -c 'uname -o 2>/dev/null || echo not'),Cygwin)
  DEBUG =
else
  DEBUG = -D_GLIBCXX_DEBUG
endif
#PROFILE = -pg
#OTHERS = -O3
#DEFINES = -DNDEBUG

# Disable debug. Comment this out to get logging.
#DEFINES = -DENABLE_LOGGING

# Limit debug to level. Comment out all for all levels.
#DEFINES += -DDEBUG_INFO
#DEFINES += -DDEBUG_WARNING
#DEFINES += -DDEBUG_ERROR
#DEFINES += -DDEBUG_PEDANTIC_INFO

# Limit debug to section. Comment out all for all levels.
#DEFINES += -DDEBUG_ENABLE_MAIN
#DEFINES += -DDEBUG_ENABLE_MAP
#DEFINES += -DDEBUG_ENABLE_MAP_GEN
#DEFINES += -DDEBUG_ENABLE_GAME

# Explicitly let 'char' to be 'signed char' to fix #18776
OTHERS += -fsigned-char

VERSION = 0.D

TARGET_NAME = cataclysm
TILES_TARGET_NAME = $(TARGET_NAME)-tiles

TARGET = $(BUILD_PREFIX)$(TARGET_NAME)
TILESTARGET = $(BUILD_PREFIX)$(TILES_TARGET_NAME)
ifdef TILES
  APPTARGET = $(TILESTARGET)
else
  APPTARGET = $(TARGET)
endif
W32TILESTARGET = $(BUILD_PREFIX)$(TILES_TARGET_NAME).exe
W32TARGET = $(BUILD_PREFIX)$(TARGET_NAME).exe
CHKJSON_BIN = $(BUILD_PREFIX)chkjson
BINDIST_DIR = $(BUILD_PREFIX)bindist
BUILD_DIR = $(CURDIR)
SRC_DIR = src
LUA_DIR = lua
LUASRC_DIR = $(SRC_DIR)/$(LUA_DIR)
# if you have LUAJIT installed, try make LUA_BINARY=luajit for extra speed
LUA_BINARY = lua
LOCALIZE = 1
ASTYLE_BINARY = astyle

# Enable astyle by default
ifndef ASTYLE
  ASTYLE = 1
endif

# Enable json format check by default
ifndef LINTJSON
  LINTJSON = 1
endif

# Enable running tests by default
ifndef RUNTESTS
  RUNTESTS = 1
endif

# Enable backtrace by default
ifndef BACKTRACE
  # ...except not on native Windows builds, because the relevant headers are
  # probably not available
  ifneq ($(MSYS2), 1)
    BACKTRACE = 1
  endif
endif

ifeq ($(RUNTESTS), 1)
  TESTS = tests
endif

# tiles object directories are because gcc gets confused # Appears that the default value of $LD is unsuitable on most systems

# when preprocessor defines change, but the source doesn't
ODIR = $(BUILD_PREFIX)obj
ODIRTILES = $(BUILD_PREFIX)obj/tiles
W32ODIR = $(BUILD_PREFIX)objwin
W32ODIRTILES = $(W32ODIR)/tiles

ifdef AUTO_BUILD_PREFIX
  BUILD_PREFIX = $(if $(RELEASE),release-)$(if $(DEBUG_SYMBOLS),symbol-)$(if $(TILES),tiles-)$(if $(SOUND),sound-)$(if $(LOCALIZE),local-)$(if $(BACKTRACE),back-)$(if $(SANITIZE),sanitize-)$(if $(MAPSIZE),map-$(MAPSIZE)-)$(if $(LUA),lua-)$(if $(USE_XDG_DIR),xdg-)$(if $(USE_HOME_DIR),home-)$(if $(DYNAMIC_LINKING),dynamic-)$(if $(MSYS2),msys2-)
  export BUILD_PREFIX
endif

OS  = $(shell uname -s)

# if $(OS) contains 'BSD'
ifneq ($(findstring BSD,$(OS)),)
  BSD = 1
endif

# This sets CXX and so must be up here
ifdef CLANG
  # Allow setting specific CLANG version
  ifeq ($(CLANG), 1)
    CLANGCMD = clang++
  else
    CLANGCMD = $(CLANG)
  endif
  ifeq ($(NATIVE), osx)
    USE_LIBCXX = 1
  endif
  ifdef USE_LIBCXX
    OTHERS += -stdlib=libc++
    LDFLAGS += -stdlib=libc++
  endif
  ifdef CCACHE
    CXX = CCACHE_CPP2=1 ccache $(CROSS)$(CLANGCMD)
    LD  = CCACHE_CPP2=1 ccache $(CROSS)$(CLANGCMD)
  else
    CXX = $(CROSS)$(CLANGCMD)
    LD  = $(CROSS)$(CLANGCMD)
  endif
else
  # Compiler version & target machine - used later for MXE ICE workaround
  ifdef CROSS
    CXXVERSION := $(shell $(CROSS)$(CXX) --version | grep -i gcc | sed 's/^.* //g')
    CXXMACHINE := $(shell $(CROSS)$(CXX) -dumpmachine)
  endif

  # Expand at reference time to avoid recursive reference
  OS_COMPILER := $(CXX)
  # Appears that the default value of $LD is unsuitable on most systems
  OS_LINKER := $(CXX)
  ifdef CCACHE
    CXX = ccache $(CROSS)$(OS_COMPILER)
    LD  = ccache $(CROSS)$(OS_LINKER)
  else
    CXX = $(CROSS)$(OS_COMPILER)
    LD  = $(CROSS)$(OS_LINKER)
  endif
endif

STRIP = $(CROSS)strip
RC  = $(CROSS)windres
AR  = $(CROSS)ar

# We don't need scientific precision for our math functions, this lets them run much faster.
CXXFLAGS += -ffast-math
LDFLAGS += $(PROFILE)

ifneq ($(SANITIZE),)
  CXXFLAGS += -fsanitize=$(SANITIZE)
  LDFLAGS += -fsanitize=$(SANITIZE)
endif

# enable optimizations. slow to build
ifdef RELEASE
  ifeq ($(NATIVE), osx)
    ifdef OSXCROSS
      OPTLEVEL = -O0
    else ifeq ($(shell expr $(OSX_MIN) \<= 10.11), 1)
      OPTLEVEL = -O0
    else
      ifeq ($(shell $(CXX) -E -Os - < /dev/null > /dev/null 2>&1 && echo fos),fos)
        OPTLEVEL = -Os
      else
        OPTLEVEL = -O3
      endif
    endif
  else
    # MXE ICE Workaround
    # known bad on 4.9.3 and 4.9.4, if it gets fixed this could include a version test too
    ifeq ($(CXXMACHINE), x86_64-w64-mingw32.static)
      OPTLEVEL = -O3
    else
      OPTLEVEL = -Os
    endif
  endif
  ifdef LTO
    ifdef CLANG
      # LLVM's LTO will complain if the optimization level isn't between O0 and
      # O3 (inclusive)
      OPTLEVEL = -O3
    endif
  endif
  CXXFLAGS += $(OPTLEVEL)

  ifdef LTO
    LDFLAGS += -fuse-ld=gold
    ifdef CLANG
      LTOFLAGS += -flto
    else
      LTOFLAGS += -flto=jobserver -flto-odr-type-merging
    endif
  endif
  CXXFLAGS += $(LTOFLAGS)

  # OTHERS += -mmmx -m3dnow -msse -msse2 -msse3 -mfpmath=sse -mtune=native
  # Strip symbols, generates smaller executable.
  OTHERS += $(RELEASE_FLAGS)
  DEBUG =
  ifndef DEBUG_SYMBOLS
    DEBUGSYMS =
  endif
  DEFINES += -DRELEASE
  # Check for astyle or JSON regressions on release builds.
  ifeq ($(ASTYLE), 1)
    CHECKS += astyle-check
  endif
  ifeq ($(LINTJSON), 1)
    CHECKS += style-json
  endif
endif

ifndef RELEASE
  ifeq ($(shell $(CXX) -E -Og - < /dev/null > /dev/null 2>&1 && echo fog),fog)
    OPTLEVEL = -Og
  else
    OPTLEVEL = -O0
  endif
  CXXFLAGS += $(OPTLEVEL)
endif

ifeq ($(shell sh -c 'uname -o 2>/dev/null || echo not'),Cygwin)
  OTHERS += -std=gnu++11
else
  OTHERS += -std=c++11
endif

CXXFLAGS += $(WARNINGS) $(DEBUG) $(DEBUGSYMS) $(PROFILE) $(OTHERS) -MMD -MP

BINDIST_EXTRAS += README.md data doc
BINDIST    = $(BUILD_PREFIX)cataclysmdda-$(VERSION).tar.gz
W32BINDIST = $(BUILD_PREFIX)cataclysmdda-$(VERSION).zip
BINDIST_CMD    = tar --transform=s@^$(BINDIST_DIR)@cataclysmdda-$(VERSION)@ -czvf $(BINDIST) $(BINDIST_DIR)
W32BINDIST_CMD = cd $(BINDIST_DIR) && zip -r ../$(W32BINDIST) * && cd $(BUILD_DIR)


# Check if called without a special build target
ifeq ($(NATIVE),)
  ifeq ($(CROSS),)
    ifeq ($(shell sh -c 'uname -o 2>/dev/null || echo not'),Cygwin)
      DEFINES += -DCATA_NO_CPP11_STRING_CONVERSIONS
      TARGETSYSTEM=CYGWIN
    else
      TARGETSYSTEM=LINUX
    endif
  endif
endif

# Linux 64-bit
ifeq ($(NATIVE), linux64)
  CXXFLAGS += -m64
  LDFLAGS += -m64
  TARGETSYSTEM=LINUX
  ifdef GOLD
    CXXFLAGS += -fuse-ld=gold
    LDFLAGS += -fuse-ld=gold
  endif
else
  # Linux 32-bit
  ifeq ($(NATIVE), linux32)
    CXXFLAGS += -m32
    LDFLAGS += -m32
    TARGETSYSTEM=LINUX
    ifdef GOLD
      CXXFLAGS += -fuse-ld=gold
      LDFLAGS += -fuse-ld=gold
    endif
  endif
endif

# OSX
ifeq ($(NATIVE), osx)
  ifdef CLANG
    OSX_MIN = 10.7
  else
    OSX_MIN = 10.5
  endif
  DEFINES += -DMACOSX
  CXXFLAGS += -mmacosx-version-min=$(OSX_MIN)
  LDFLAGS += -mmacosx-version-min=$(OSX_MIN) -framework CoreFoundation
  ifdef FRAMEWORK
    ifeq ($(FRAMEWORKSDIR),)
      FRAMEWORKSDIR := $(strip $(if $(shell [ -d $(HOME)/Library/Frameworks ] && echo 1), \
                             $(if $(shell find $(HOME)/Library/Frameworks -name 'SDL2.*'), \
                               $(HOME)/Library/Frameworks,),))
    endif
    ifeq ($(FRAMEWORKSDIR),)
      FRAMEWORKSDIR := $(strip $(if $(shell find /Library/Frameworks -name 'SDL2.*'), \
                                 /Library/Frameworks,))
    endif
    ifeq ($(FRAMEWORKSDIR),)
      $(error "SDL2 framework not found")
    endif
  endif
  ifeq ($(LOCALIZE), 1)
    LDFLAGS += -lintl
    ifdef OSXCROSS
      LDFLAGS += -L$(LIBSDIR)/gettext/lib
      CXXFLAGS += -I$(LIBSDIR)/gettext/include
    endif
    ifeq ($(MACPORTS), 1)
      ifneq ($(TILES), 1)
        CXXFLAGS += -I$(shell ncursesw6-config --includedir)
        LDFLAGS += -L$(shell ncursesw6-config --libdir)
      endif
    endif
  endif
  TARGETSYSTEM=LINUX
  ifneq ($(OS), Linux)
    BINDIST_CMD = tar -s"@^$(BINDIST_DIR)@cataclysmdda-$(VERSION)@" -czvf $(BINDIST) $(BINDIST_DIR)
  endif
endif

# Win32 (MinGW32 or MinGW-w64(32bit)?)
ifeq ($(NATIVE), win32)
# Any reason not to use -m32 on MinGW32?
  TARGETSYSTEM=WINDOWS
else
  # Win64 (MinGW-w64?)
  ifeq ($(NATIVE), win64)
    CXXFLAGS += -m64
    LDFLAGS += -m64
    TARGETSYSTEM=WINDOWS
  endif
endif

# MSYS2
ifeq ($(MSYS2), 1)
  TARGETSYSTEM=WINDOWS
endif

# Cygwin
ifeq ($(NATIVE), cygwin)
  TARGETSYSTEM=CYGWIN
endif

# MXE cross-compile to win32

=== lang/CMakeLists.txt ===
MESSAGE(STATUS "Process LINGUAS variable --\n")

FIND_PACKAGE(Gettext)

IF (NOT GETTEXT_FOUND)
	MESSAGE(FATAL_ERROR
		"Gettext not found. Install gettext package or diable
		localization with: -DLOCALIZE=OFF \nSee INSTALL file for details and more info\n"
	)
ENDIF (NOT GETTEXT_FOUND)

foreach (LANG ${LANGUAGES})
	MESSAGE(STATUS "Add translation for ${LANG}: ${LANG}.po")
endforeach ()
MESSAGE("\n")

# Extract json strings

add_custom_target (
	extract_string
	COMMAND python lang/extract_json_strings.py
	WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
)

# Generate cataclysm-dda.pot
add_custom_target (
	translations
	COMMAND xgettext --default-domain="cataclysm-dda"
			 --sort-by-file
			 --add-comments="~"
			 --output="${CMAKE_SOURCE_DIR}/lang/po/cataclysm-dda.pot"
			 --keyword="_"
			 --keyword="pgettext:1c,2"
			 --keyword="ngettext:1,2"
			 --from-code="UTF-8"
			 ${CMAKE_SOURCE_DIR}/src/*.cpp
			 ${CMAKE_SOURCE_DIR}/src/*.h
			 ${CMAKE_SOURCE_DIR}/lang/json/*.py
	WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
	DEPENDS extract_string
)

add_custom_target (
	translations_prepare
	WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
)

# Auto-Compile translation on release builds only
IF (RELEASE)
	add_custom_target (
		translations_compile
		ALL
		WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
		DEPENDS translations_prepare
	)
ELSE (RELEASE)
	add_custom_target (
		translations_compile
		WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
		DEPENDS translations_prepare
	)
ENDIF (RELEASE)

foreach (LANG ${LANGUAGES})
	add_custom_command (
		TARGET translations_prepare
		PRE_BUILD
		COMMAND ${CMAKE_COMMAND}
		        -E make_directory ${CMAKE_SOURCE_DIR}/lang/mo/${LANG}/LC_MESSAGES
		WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
	)
	add_custom_command (
		TARGET translations_compile
		PRE_BUILD
		COMMAND 
		${GETTEXT_MSGFMT_EXECUTABLE} -f ${CMAKE_SOURCE_DIR}/lang/po/${LANG}.po
		       -o ${CMAKE_SOURCE_DIR}/lang/mo/${LANG}/LC_MESSAGES/cataclysm-dda.mo
		WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
	)
	IF(RELEASE)
		IF (${CMAKE_SYSTEM_NAME} MATCHES Windows)
			#install(DIRECTORY ${CMAKE_SOURCE_DIR}/lang/mo/${LANG} DESTINATION ${DATA_PREFIX})
		ELSE (${CMAKE_SYSTEM_NAME} MATCHES Windows)
			install(DIRECTORY ${CMAKE_SOURCE_DIR}/lang/mo/${LANG} DESTINATION ${LOCALE_DIR})
		ENDIF (${CMAKE_SYSTEM_NAME} MATCHES Windows)
	ENDIF(RELEASE)
endforeach()

=== lua/CMakeLists.txt ===
# LUA files + test
cmake_minimum_required(VERSION 2.8.12)

SET(CATACLYSM_DDA_LUA_SOURCES
    ${CMAKE_SOURCE_DIR}/lua/class_definitions.lua
    ${CMAKE_SOURCE_DIR}/lua/autoexec.lua
)

# test chain
add_custom_target (
	check_lua
	WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
)

add_custom_command (
	TARGET check_lua
	PRE_BUILD
	COMMAND ${LUA_BINARY} lua/json_verifier.lua
	WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
)

IF(RELEASE)
	install(FILES ${CATACLYSM_DDA_LUA_SOURCES} DESTINATION ${DATA_PREFIX}/lua)
ENDIF(RELEASE)

=== tests/Makefile ===
# Make any tests, and possibly run them.
# A selection of variables are exported from the master Makefile.

# As each test will have a main function we need to handle this file by file.
# We're using the fairly typical convention that any file ending in _test.cpp
# is a test executable.
SOURCES = $(wildcard *.cpp)
OBJS = $(sort $(SOURCES:%.cpp=$(ODIR)/%.o))

CATA_LIB=../$(BUILD_PREFIX)cataclysm.a

# If you invoke this makefile directly and the parent directory was
# built with BUILD_PREFIX set, you must set it for this invocation as well.
ODIR ?= obj

LDFLAGS += -L.

# Allow use of any header files from cataclysm.
# Catch sections throw unused variable warnings.
# Add no-sign-compare to fix MXE issue when compiling
# Catch also uses "#pragma gcc diagnostic", which is not recognized on some supported compilers.
# Clang and mingw are warning about Catch macros around perfectly normal boolean operations.
CXXFLAGS += -I../src -Wno-unused-variable -Wno-sign-compare -Wno-unknown-pragmas -Wno-parentheses -MMD -MP
CXXFLAGS += -Wall -Wextra

TEST_TARGET = $(BUILD_PREFIX)cata_test

tests: $(TEST_TARGET)

$(BUILD_PREFIX)cata_test: $(OBJS) $(CATA_LIB)
	+$(CXX) $(W32FLAGS) -o $@ $(DEFINES) $(OBJS) $(CATA_LIB) $(CXXFLAGS) $(LDFLAGS)

# Iterate over all the individual tests.
check: $(TEST_TARGET)
	cd .. && tests/$(TEST_TARGET) -d yes -r cata --rng-seed time

clean:
	rm -rf *obj
	rm -f *cata_test

#Unconditionally create object directory on invocation.
$(shell mkdir -p $(ODIR))

$(ODIR)/%.o: %.cpp
	$(CXX) $(DEFINES) $(CXXFLAGS) -c $< -o $@

.PHONY: clean check tests

.SECONDARY: $(OBJS)

-include ${OBJS:.o=.d}

=== src/lua/CMakeLists.txt ===
# CataclysmDDA Lua bindings
cmake_minimum_required(VERSION 2.8.12)

MESSAGE(STATUS "Searching for Lua library --\n")

SET(CATACLYSM_DDA_LUA_BINDING_SOURCES
    ${CMAKE_SOURCE_DIR}/lua/class_definitions.lua
    ${CMAKE_SOURCE_DIR}/src/lua/generate_bindings.lua
)

add_custom_target (
	lua_bindings
	ALL
	DEPENDS ${CMAKE_SOURCE_DIR}/src/lua/catabindings.cpp
	WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
)

ADD_CUSTOM_COMMAND (
	OUTPUT ${CMAKE_SOURCE_DIR}/src/lua/catabindings.cpp
	COMMAND ${LUA_BINARY} generate_bindings.lua
	DEPENDS ${CATACLYSM_DDA_LUA_BINDING_SOURCES}
	WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}/src/lua
)

=== debian/changelog ===
cataclysm-dda (0.D-4build1) focal; urgency=medium

  * No-change rebuild for libgcc-s1 package name change.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 22 Mar 2020 16:35:43 +0100

cataclysm-dda (0.D-4) unstable; urgency=medium

  * Disable flaky crafting_test.

 -- Reiner Herrmann <reiner@reiner-h.de>  Thu, 15 Aug 2019 18:59:43 +0200

cataclysm-dda (0.D-3) unstable; urgency=medium

  * Upload to unstable.
  * Revert "Point to experimental branch in Vcs-Git".
  * Update website URLs in upstream files.
  * Update upstream metadata.
  * Bump Standards-Version to 4.4.0; no changes required.
  * Depend on debhelper-compat 12.
  * Install binaries from d/tmp so that dh_missing recognizes them.
  * Split upstream install target into -bin and -data targets.
  * Speed up arch:all-only builds by splitting d/rules targets into -arch
    and -indep targets.

 -- Reiner Herrmann <reiner@reiner-h.de>  Fri, 12 Jul 2019 22:06:24 +0200

cataclysm-dda (0.D-2) experimental; urgency=medium

  * Fix build with gcc9. (Closes: #925648)
  * Point to experimental branch in Vcs-Git.

 -- Reiner Herrmann <reiner@reiner-h.de>  Sat, 06 Apr 2019 13:40:03 +0200

cataclysm-dda (0.D-1) experimental; urgency=medium

  * New upstream release.
  * Update homepage.
  * Drop patches applied upstream.

 -- Reiner Herrmann <reiner@reiner-h.de>  Tue, 12 Mar 2019 19:38:29 +0100

=== debian/control ===
Source: cataclysm-dda
Maintainer: Reiner Herrmann <reiner@reiner-h.de>
Section: games
Priority: optional
Build-Depends: debhelper-compat (= 12),
               liblua5.3-dev,
               libsdl2-dev,
               libsdl2-image-dev,
               libsdl2-mixer-dev,
               libsdl2-ttf-dev,
               lua5.3,
               pkg-config
Build-Depends-Arch: libncursesw5-dev,
                    librsvg2-bin
Standards-Version: 4.4.0
Rules-Requires-Root: no
Homepage: https://cataclysmdda.org/
Vcs-Git: https://salsa.debian.org/deki-guest/cataclysm-dda.git
Vcs-Browser: https://salsa.debian.org/deki-guest/cataclysm-dda

Package: cataclysm-dda-data
Architecture: all
Multi-Arch: foreign
Depends: ttf-unifont,
         ${misc:Depends}
Description: post-apocalyptic roguelike game - data files
 Cataclysm: Dark Days Ahead is a roguelike set in a post-apocalyptic world.
 .
 While some have described it as a "zombie game", there's far more to Cataclysm
 than that. Struggle to survive in a harsh, persistent, procedurally generated
 world. Scavenge the remnants of a dead civilization for food, equipment, or,
 if you're lucky, a vehicle with a full tank of gas to get you the hell out of
 Dodge. Fight to defeat or escape from a wide variety of powerful monstrosities,
 from zombies to giant insects to killer robots and things far stranger and
 deadlier, and against the others like yourself, that want what you have...
 .
 This package contains the data files required by any of the frontends.

Package: cataclysm-dda-curses
Architecture: any
Depends: cataclysm-dda-data (= ${source:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Provides: cataclysm-dda
Description: post-apocalyptic roguelike game - curses interface
 Cataclysm: Dark Days Ahead is a roguelike set in a post-apocalyptic world.
 .
 While some have described it as a "zombie game", there's far more to Cataclysm
 than that. Struggle to survive in a harsh, persistent, procedurally generated
 world. Scavenge the remnants of a dead civilization for food, equipment, or,
 if you're lucky, a vehicle with a full tank of gas to get you the hell out of
 Dodge. Fight to defeat or escape from a wide variety of powerful monstrosities,
 from zombies to giant insects to killer robots and things far stranger and
 deadlier, and against the others like yourself, that want what you have...
 .
 This package contains the text-only ncurses-based interface.

Package: cataclysm-dda-sdl
Architecture: any
Depends: cataclysm-dda-data (= ${source:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Provides: cataclysm-dda
Description: post-apocalyptic roguelike game - SDL interface
 Cataclysm: Dark Days Ahead is a roguelike set in a post-apocalyptic world.
 .
 While some have described it as a "zombie game", there's far more to Cataclysm
 than that. Struggle to survive in a harsh, persistent, procedurally generated
 world. Scavenge the remnants of a dead civilization for food, equipment, or,
 if you're lucky, a vehicle with a full tank of gas to get you the hell out of
 Dodge. Fight to defeat or escape from a wide variety of powerful monstrosities,
 from zombies to giant insects to killer robots and things far stranger and
 deadlier, and against the others like yourself, that want what you have...
 .
 This package contains the graphical SDL2-based interface.

=== debian/rules ===
#!/usr/bin/make -f

#DH_VERBOSE = 1

include /usr/share/dpkg/pkg-info.mk

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

SDL_FLAGS = TILES=1 SOUND=1
CURSES_FLAGS =
COMMON_FLAGS = VERSION=$(DEB_VERSION_UPSTREAM) PREFIX=/usr ASTYLE=0 RELEASE=1 USE_XDG_DIR=1 LUA=1 LUA_BINARY=lua5.3 LANGUAGES=all DEBUG_SYMBOLS=1

# for building with ccache
#COMMON_FLAGS += CCACHE=1

%:
	dh $@

override_dh_auto_build-arch:
	dh_auto_build -- $(COMMON_FLAGS) $(CURSES_FLAGS)
	dh_auto_build -- $(COMMON_FLAGS) $(SDL_FLAGS)
	# generate icons
	for size in 16 32 64 128; do \
		mkdir -p debian/icons/hicolor/$${size}x$${size}/apps; \
		rsvg-convert -o debian/icons/hicolor/$${size}x$${size}/apps/cataclysm-dda.png -w $${size} data/xdg/cataclysm-dda.svg ; \
	done

override_dh_auto_build-indep:

override_dh_auto_install-arch:
	$(MAKE) install-bin DESTDIR=debian/tmp $(COMMON_FLAGS) $(CURSES_FLAGS)
	$(MAKE) install-bin DESTDIR=debian/tmp $(COMMON_FLAGS) $(SDL_FLAGS)

override_dh_auto_install-indep:
	$(MAKE) install-data DESTDIR=debian/tmp $(COMMON_FLAGS) $(SDL_FLAGS)

override_dh_auto_test-arch:
	# we need to pass build flags, otherwise some files are regenerated
	# and the binaries are relinked.
	LC_ALL=C.UTF-8 XDG_CONFIG_HOME=. dh_auto_test -- $(COMMON_FLAGS)

override_dh_auto_test-indep:

override_dh_install:
	dh_install -Xfont/ -Xcataicon.ico -XLICENSE.txt -Xchangelog.txt

override_dh_clean:
	$(MAKE) clean distclean
	dh_clean

override_dh_installchangelogs:
	dh_installchangelogs data/changelog.txt
